<script>
import io from "socket.io-client";

export default {
  name: "HomePage",
  data() {
    return {
      userLogin: {
        isLogged: false,
        username: "",
        fullname: "",
      },
      input: {
        username: "",
        fullname: "",
      },
      socketio: null,
      rooms: [],
      roomActive: null,
      roomMessage: [],
      message: "",
    };
  },
  computed: {
    classCheck: function () {
      const caseDefine = [
        "ACCOUNT" + "#" + this.userLogin.username,
        "ACCOUNT" + "#" + this.roomActive.username,
      ];
      return caseDefine.join(":");
    },
  },
  created() {
    this.socketio = io("http://localhost:5555/");
  },
  mounted() {
    const userData = JSON.parse(localStorage.getItem("user"));
    this.socketio.on("user-online-list", (rooms) => {
      if (userData) {
        this.rooms = rooms.filter(
          (r) => r.username !== this.userLogin.username
        );
      }
    });
    this.socketio.on("history", (messages) => {
      this.roomMessage = messages;
    });
    this.socketio.on("message", (message) => {
      this.roomMessage.push(message);
    });
    if (userData) {
      this.userLogin = userData;
      this.socketio.emit("user-login", userData);
      const roomActive = this.roomActive;
      if (roomActive) {
        const roomKey = roomActive.type + "#" + roomActive.username;
        this.socketio.emit("join-room", roomKey);
      }
    }
  },
  methods: {
    login() {
      if (this.input.username && this.input.fullname) {
        this.userLogin = {
          isLogged: true,
          username: this.input.username,
          fullname: this.input.fullname,
        };
        this.socketio.emit("user-login", this.input);
        localStorage.setItem("user", JSON.stringify(this.userLogin));
        this.input = {
          username: "",
          fullname: "",
        };
      }
    },
    logout() {
      this.socketio.emit("user-logout", this.userLogin);
      localStorage.removeItem("user");
      this.userLogin = {
        isLogged: false,
        username: "",
        fullname: "",
      };
      this.roomMessage = [];
      this.roomActive = null;
    },
    active(room) {
      const roomActive = this.roomActive;
      if (this.roomActive) {
        return roomActive.username === room.username ? "active" : "";
      }
    },
    joinRoom(room) {
      this.roomActive =
        this.roomActive && this.roomActive.username === room.username
          ? null
          : room;
      if (this.roomActive) {
        this.socketio.emit("join-room", {
          username: this.userLogin.fullname,
          from: this.userLogin.username,
          to: this.roomActive.username,
          type: "ACCOUNT",
        });
      }
    },
    messageClass(message) {
      return message.from === this.userLogin.username ? "you" : "friend";
    },
    send() {
      this.socketio.emit("message", {
        fullname: this.userLogin.fullname,
        from: this.userLogin.username,
        to: this.roomActive.username,
        type: "ACCOUNT",
        message: this.message,
      });
      this.message = "";
    },
  },
};
</script>

<template>
  <div>
    <div class="flex" v-if="userLogin.isLogged">
      <div class="col-left">
        <div
          v-for="(room, index) in rooms"
          @click="joinRoom(room)"
          class="col-left__items"
          :class="active(room)"
          :key="index"
        >
          {{ room.fullname }}
        </div>
        <button @click="logout">Logout</button>
      </div>
      <div class="col-right" v-if="roomActive">
        <template
          v-for="(message, index) in roomMessage"
          :key="index"
        >
          <div :class="messageClass(message)" class="message" v-if="message.code.includes(classCheck)">
            <strong>{{ message.fullname }}: </strong>{{ message.message }}
          </div>
        </template>
        <div class="chatting">
          <input type="text" v-model="message" @keyup.enter="send" />
        </div>
      </div>
    </div>
    <div class="login" v-else>
      <input type="text" placeholder="Username" v-model="input.username" />
      <input type="text" placeholder="Fullname" v-model="input.fullname" />
      <button @click="login">Login</button>
    </div>
  </div>
</template>

<style>
* {
  box-sizing: border-box;
}

body {
  margin: 0;
  padding: 0;
  font-family: -apple-system, BlinkMacSystemFont, "Segoe UI", Roboto, Oxygen,
    Ubuntu, Cantarell, "Open Sans", "Helvetica Neue", sans-serif;
  font-size: 0.875rem;
}

.flex {
  display: flex;
}

.col-left {
  min-width: 300px;
  width: 300px;
  height: 100vh;
  background: rgb(0, 18, 153);
  padding: 1rem;
  display: flex;
  flex-direction: column;
  gap: 0.5rem;
}

.col-left__items {
  padding: 1rem;
  background: rgb(60, 76, 196);
  border-radius: 0.6rem;
  color: rgb(157, 169, 255);
  cursor: pointer;
  border: 1px solid transparent;
  transition: all 0.2s;
}

.col-left__items:hover,
.col-left__items.active {
  color: #ffffff;
  background: rgb(36, 53, 179);
  border: 1px solid rgb(157, 169, 255);
}

.col-left button {
  margin-top: auto;
  padding: 0.6rem;
  cursor: pointer;
}

.col-right {
  display: flex;
  flex-direction: column;
  width: 100%;
  padding: 1rem 0;
  gap: 0.6rem;
  position: relative;
}

.col-right .message {
  width: 50%;
  padding: 0.6rem;
}

.col-right .message.you {
  margin-left: auto;
  border-top-left-radius: 0.6rem;
  border-bottom-left-radius: 0.6rem;
  background: rgb(36, 53, 179);
  color: #ffffff;
}

.col-right .message.friend {
  border-top-right-radius: 0.6rem;
  border-bottom-right-radius: 0.6rem;
  background: rgb(221, 221, 221);
}

.chatting {
  position: absolute;
  bottom: 0;
  padding: 1rem;
  width: 100%;
  left: 0;
}

.chatting input {
  width: 100%;
  padding: 0.6rem;
  outline: none;
}

.login {
  margin: 100px auto;
  width: 500px;
  padding: 1rem;
  background: rgb(36, 53, 179);
}

.login input {
  margin-bottom: 0.875rem;
}

.login button {
  cursor: pointer;
}

.login input,
.login button {
  padding: 0.6rem;
  width: 100%;
  outline: none;
}
</style>
